Index: trunk/sources/HeuristicLab.Operators/3.3/CombinedOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/CombinedOperator.cs	(revision 2664)
+++ trunk/sources/HeuristicLab.Operators/3.3/CombinedOperator.cs	(revision 2684)
@@ -22,6 +22,8 @@
 using System;
 using System.Collections.Generic;
+using System.Drawing;
 using System.Text;
 using System.Xml;
+using HeuristicLab.Collections;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
@@ -30,101 +32,45 @@
 namespace HeuristicLab.Operators {
   /// <summary>
-  /// Contains an operator graph and automatically injects its sub-operators into the scope it is 
-  /// applied on (useful for modularization to assemble complex operators out of simpler ones).
+  /// Operator which contains an operator graph.
   /// </summary>
-  public class CombinedOperator : DelegatingOperator {
-
+  [Item("CombinedOperator", "An operator which contains an operator graph.")]
+  [Creatable("Test")]
+  public sealed class CombinedOperator : StandardOperator, IOperator {
+    public override Image ItemImage {
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Module; }
+    }
     [Storable]
-    private string myDescription;
-    /// <summary>
-    /// Gets the description of the current instance.
-    /// </summary>
-    public override string Description {
-      get { return myDescription; }
+    private OperatorGraph operatorGraph;
+    public OperatorGraph OperatorGraph {
+      get { return operatorGraph; }
+    }
+    public new ParameterCollection Parameters {
+      get {
+        return base.Parameters;
+      }
+    }
+    IObservableKeyedCollection<string, IParameter> IOperator.Parameters {
+      get { return Parameters; }
+    }
+    public override bool CanChangeDescription {
+      get { return true; }
     }
 
-    [Storable]
-    private IOperatorGraph myOperatorGraph;
-    /// <summary>
-    /// Gets the operator graph of the current instance.
-    /// </summary>
-    public IOperatorGraph OperatorGraph {
-      get { return myOperatorGraph; }
+    public CombinedOperator()
+      : base() {
+      operatorGraph = new OperatorGraph();
     }
 
-    /// <summary>
-    /// Initializes a new instance of <see cref="CombinedOperator"/>.
-    /// </summary>
-    public CombinedOperator()
-      : base() {
-      myDescription =
-        @"A combined operator contains a whole operator graph. It is useful for modularization to assemble complex operators out of simpler ones.
-
-A combined operator automatically inject its sub-operators into the scope it is applied on. Thereby the names of the sub-operators are used as variable names. Those operators can be extracted again in the contained operator graph by using an OperatorExtractor. So it is possible to parameterize a combined operator with custom operators.";
-      myOperatorGraph = new OperatorGraph();
+    public override IDeepCloneable Clone(Cloner cloner) {
+      CombinedOperator clone = (CombinedOperator)base.Clone(cloner);
+      clone.operatorGraph = (OperatorGraph)cloner.Clone(operatorGraph);
+      return base.Clone(cloner);
     }
 
-    /// <summary>
-    /// Sets the description of the current instance.
-    /// </summary>
-    /// <remarks>Calls <see cref="OnDescriptionChanged"/>.</remarks>
-    /// <exception cref="NullReferenceException">Thrown when <paramref name="description"/> is <c>null</c>.</exception>
-    /// <param name="description">The description to set.</param>
-    public void SetDescription(string description) {
-      if (description == null)
-        throw new NullReferenceException("description must not be null");
-
-      if (description != myDescription) {
-        myDescription = description;
-        OnDescriptionChanged();
-      }
-    }
-
-    /// <summary>
-    /// Clones the current instance (deep clone).
-    /// </summary>
-    /// <remarks>Calls <see cref="OperatorBase.Clone
-    /// (System.Collections.Generic.IDictionary&lt;System.Guid, object&gt;)"/> 
-    /// of base class <see cref="DelegatingOperator"/>.<br/>
-    /// Deep clone through <see cref="cloner.Clone"/> method of helper class 
-    /// <see cref="Auxiliary"/>.</remarks>
-    /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
-    /// <returns>The cloned object as <see cref="CombinedOperator"/>.</returns>
-    public override IItem Clone(ICloner cloner) {
-      CombinedOperator clone = (CombinedOperator)base.Clone(cloner);
-      clone.myDescription = Description;
-      clone.myOperatorGraph = (IOperatorGraph)cloner.Clone(OperatorGraph);
-      return clone;
-    }
-
-    /// <summary>
-    /// Adds all sub operators to the specified <paramref name="scope"/>.
-    /// </summary>
-    /// <param name="scope">The scope where to inject the sub operators.</param>
-    /// <returns><c>null</c> if the initial operator is <c>nulll</c>, else a new 
-    /// <see cref="AtomicOperation"/> with the initial operator and the given <paramref name="scope"/>.</returns>
-    public override IOperation Apply(IScope scope) {
-      if (OperatorGraph.InitialOperator != null) {
-        for (int i = 0; i < SubOperators.Count; i++) {
-          if (scope.GetVariable(SubOperators[i].Name) != null)
-            scope.RemoveVariable(SubOperators[i].Name);
-          scope.AddVariable(new Variable(SubOperators[i].Name, SubOperators[i]));
-        }
-        return new AtomicOperation(OperatorGraph.InitialOperator, scope);
-      } else {
-        return null;
-      }
-    }
-
-    /// <summary>
-    /// Occurs when the description of the current instance has been changed.
-    /// </summary>
-    public event EventHandler DescriptionChanged;
-    /// <summary>
-    /// Fires a new <c>DescriptionChanged</c> event.
-    /// </summary>
-    protected virtual void OnDescriptionChanged() {
-      if (DescriptionChanged != null)
-        DescriptionChanged(this, new EventArgs());
+    public override ExecutionContextCollection Apply(ExecutionContext context) {
+      ExecutionContextCollection next = base.Apply(context);
+      if (operatorGraph.InitialOperator != null)
+        next.Insert(0, new ExecutionContext(context, operatorGraph.InitialOperator, context.Scope));
+      return next;
     }
   }
Index: trunk/sources/HeuristicLab.Operators/3.3/CombinedOperatorView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/CombinedOperatorView.Designer.cs	(revision 2664)
+++ 	(revision )
@@ -1,224 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Operators {
-  partial class CombinedOperatorView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.tabControl = new System.Windows.Forms.TabControl();
-      this.operatorGraphTabPage = new System.Windows.Forms.TabPage();
-      this.operatorGraphView = new HeuristicLab.Core.Views.OperatorGraphView();
-      this.variableInfosTabPage = new System.Windows.Forms.TabPage();
-      this.operatorBaseVariableInfosView = new HeuristicLab.Core.Views.OperatorBaseVariableInfosView();
-      this.variablesTabPage = new System.Windows.Forms.TabPage();
-      this.operatorBaseVariablesView = new HeuristicLab.Core.Views.OperatorBaseVariablesView();
-      this.descriptionTabPage = new System.Windows.Forms.TabPage();
-      this.descriptionTextBox = new System.Windows.Forms.TextBox();
-      this.removeVariableInfoButton = new System.Windows.Forms.Button();
-      this.addVariableInfoButton = new System.Windows.Forms.Button();
-      this.tabControl.SuspendLayout();
-      this.operatorGraphTabPage.SuspendLayout();
-      this.variableInfosTabPage.SuspendLayout();
-      this.variablesTabPage.SuspendLayout();
-      this.descriptionTabPage.SuspendLayout();
-      this.SuspendLayout();
-      // 
-      // tabControl
-      // 
-      this.tabControl.Controls.Add(this.operatorGraphTabPage);
-      this.tabControl.Controls.Add(this.variableInfosTabPage);
-      this.tabControl.Controls.Add(this.variablesTabPage);
-      this.tabControl.Controls.Add(this.descriptionTabPage);
-      this.tabControl.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.tabControl.Location = new System.Drawing.Point(0, 0);
-      this.tabControl.Name = "tabControl";
-      this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(397, 335);
-      this.tabControl.TabIndex = 0;
-      // 
-      // operatorGraphTabPage
-      // 
-      this.operatorGraphTabPage.Controls.Add(this.operatorGraphView);
-      this.operatorGraphTabPage.Location = new System.Drawing.Point(4, 22);
-      this.operatorGraphTabPage.Name = "operatorGraphTabPage";
-      this.operatorGraphTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.operatorGraphTabPage.Size = new System.Drawing.Size(389, 309);
-      this.operatorGraphTabPage.TabIndex = 0;
-      this.operatorGraphTabPage.Text = "Operator Graph";
-      this.operatorGraphTabPage.UseVisualStyleBackColor = true;
-      // 
-      // operatorGraphView
-      // 
-      this.operatorGraphView.Caption = "Operator Graph";
-      this.operatorGraphView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.operatorGraphView.Location = new System.Drawing.Point(3, 3);
-      this.operatorGraphView.Name = "operatorGraphView";
-      this.operatorGraphView.OperatorGraph = null;
-      this.operatorGraphView.Size = new System.Drawing.Size(383, 303);
-      this.operatorGraphView.TabIndex = 0;
-      // 
-      // variableInfosTabPage
-      // 
-      this.variableInfosTabPage.Controls.Add(this.removeVariableInfoButton);
-      this.variableInfosTabPage.Controls.Add(this.addVariableInfoButton);
-      this.variableInfosTabPage.Controls.Add(this.operatorBaseVariableInfosView);
-      this.variableInfosTabPage.Location = new System.Drawing.Point(4, 22);
-      this.variableInfosTabPage.Name = "variableInfosTabPage";
-      this.variableInfosTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.variableInfosTabPage.Size = new System.Drawing.Size(389, 309);
-      this.variableInfosTabPage.TabIndex = 1;
-      this.variableInfosTabPage.Text = "Variable Infos";
-      this.variableInfosTabPage.UseVisualStyleBackColor = true;
-      // 
-      // operatorBaseVariableInfosView
-      // 
-      this.operatorBaseVariableInfosView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.operatorBaseVariableInfosView.Caption = "Operator";
-      this.operatorBaseVariableInfosView.Location = new System.Drawing.Point(3, 3);
-      this.operatorBaseVariableInfosView.Name = "operatorBaseVariableInfosView";
-      this.operatorBaseVariableInfosView.Operator = null;
-      this.operatorBaseVariableInfosView.Size = new System.Drawing.Size(383, 274);
-      this.operatorBaseVariableInfosView.TabIndex = 0;
-      this.operatorBaseVariableInfosView.SelectedVariableInfosChanged += new System.EventHandler(this.operatorBaseVariableInfosView_SelectedVariableInfosChanged);
-      // 
-      // variablesTabPage
-      // 
-      this.variablesTabPage.Controls.Add(this.operatorBaseVariablesView);
-      this.variablesTabPage.Location = new System.Drawing.Point(4, 22);
-      this.variablesTabPage.Name = "variablesTabPage";
-      this.variablesTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.variablesTabPage.Size = new System.Drawing.Size(389, 309);
-      this.variablesTabPage.TabIndex = 2;
-      this.variablesTabPage.Text = "Local Variables";
-      this.variablesTabPage.UseVisualStyleBackColor = true;
-      // 
-      // operatorBaseVariablesView
-      // 
-      this.operatorBaseVariablesView.Caption = "Operator";
-      this.operatorBaseVariablesView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.operatorBaseVariablesView.Location = new System.Drawing.Point(3, 3);
-      this.operatorBaseVariablesView.Name = "operatorBaseVariablesView";
-      this.operatorBaseVariablesView.Operator = null;
-      this.operatorBaseVariablesView.Size = new System.Drawing.Size(383, 303);
-      this.operatorBaseVariablesView.TabIndex = 0;
-      // 
-      // descriptionTabPage
-      // 
-      this.descriptionTabPage.Controls.Add(this.descriptionTextBox);
-      this.descriptionTabPage.Location = new System.Drawing.Point(4, 22);
-      this.descriptionTabPage.Name = "descriptionTabPage";
-      this.descriptionTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.descriptionTabPage.Size = new System.Drawing.Size(389, 309);
-      this.descriptionTabPage.TabIndex = 4;
-      this.descriptionTabPage.Text = "Description";
-      this.descriptionTabPage.UseVisualStyleBackColor = true;
-      // 
-      // descriptionTextBox
-      // 
-      this.descriptionTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.descriptionTextBox.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
-      this.descriptionTextBox.Location = new System.Drawing.Point(3, 3);
-      this.descriptionTextBox.Multiline = true;
-      this.descriptionTextBox.Name = "descriptionTextBox";
-      this.descriptionTextBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
-      this.descriptionTextBox.Size = new System.Drawing.Size(383, 303);
-      this.descriptionTextBox.TabIndex = 0;
-      this.descriptionTextBox.Validated += new System.EventHandler(this.descriptionTextBox_Validated);
-      // 
-      // removeVariableInfoButton
-      // 
-      this.removeVariableInfoButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.removeVariableInfoButton.Enabled = false;
-      this.removeVariableInfoButton.Location = new System.Drawing.Point(84, 283);
-      this.removeVariableInfoButton.Name = "removeVariableInfoButton";
-      this.removeVariableInfoButton.Size = new System.Drawing.Size(75, 23);
-      this.removeVariableInfoButton.TabIndex = 2;
-      this.removeVariableInfoButton.Text = "&Remove";
-      this.removeVariableInfoButton.UseVisualStyleBackColor = true;
-      this.removeVariableInfoButton.Click += new System.EventHandler(this.removeVariableInfoButton_Click);
-      // 
-      // addVariableInfoButton
-      // 
-      this.addVariableInfoButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.addVariableInfoButton.Location = new System.Drawing.Point(3, 283);
-      this.addVariableInfoButton.Name = "addVariableInfoButton";
-      this.addVariableInfoButton.Size = new System.Drawing.Size(75, 23);
-      this.addVariableInfoButton.TabIndex = 1;
-      this.addVariableInfoButton.Text = "&Add...";
-      this.addVariableInfoButton.UseVisualStyleBackColor = true;
-      this.addVariableInfoButton.Click += new System.EventHandler(this.addVariableInfoButton_Click);
-      // 
-      // CombinedOperatorView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.tabControl);
-      this.Name = "CombinedOperatorView";
-      this.Size = new System.Drawing.Size(397, 335);
-      this.tabControl.ResumeLayout(false);
-      this.operatorGraphTabPage.ResumeLayout(false);
-      this.variableInfosTabPage.ResumeLayout(false);
-      this.variablesTabPage.ResumeLayout(false);
-      this.descriptionTabPage.ResumeLayout(false);
-      this.descriptionTabPage.PerformLayout();
-      this.ResumeLayout(false);
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.TabControl tabControl;
-    private System.Windows.Forms.TabPage operatorGraphTabPage;
-    private System.Windows.Forms.TabPage variableInfosTabPage;
-    private System.Windows.Forms.TabPage variablesTabPage;
-    private System.Windows.Forms.TabPage descriptionTabPage;
-    private System.Windows.Forms.TextBox descriptionTextBox;
-    private HeuristicLab.Core.Views.OperatorGraphView operatorGraphView;
-    private HeuristicLab.Core.Views.OperatorBaseVariableInfosView operatorBaseVariableInfosView;
-    private HeuristicLab.Core.Views.OperatorBaseVariablesView operatorBaseVariablesView;
-    private System.Windows.Forms.Button removeVariableInfoButton;
-    private System.Windows.Forms.Button addVariableInfoButton;
-
-  }
-}
Index: trunk/sources/HeuristicLab.Operators/3.3/CombinedOperatorView.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/CombinedOperatorView.cs	(revision 2664)
+++ 	(revision )
@@ -1,133 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Drawing;
-using System.Data;
-using System.Text;
-using System.Windows.Forms;
-using HeuristicLab.Core;
-using HeuristicLab.Core.Views;
-using HeuristicLab.MainForm;
-
-namespace HeuristicLab.Operators {
-  /// <summary>
-  /// The visual representation of a <see cref="CombinedOperator"/>.
-  /// </summary>
-  [Content(typeof(CombinedOperator), true)]
-  public partial class CombinedOperatorView : ItemViewBase {
-    /// <summary>
-    /// Gets or sets the combined operator to display.
-    /// </summary>
-    /// <remarks>Uses property <see cref="ViewBase.Item"/> of base class <see cref="ViewBase"/>.
-    /// No own data storage present.</remarks>
-    public CombinedOperator CombinedOperator {
-      get { return (CombinedOperator)Item; }
-      set { base.Item = value; }
-    }
-
-    /// <summary>
-    /// Removes the eventhandlers in all children and from the underlying <see cref="CombinedOperator"/>.
-    /// </summary>
-    /// <remarks>Calls <see cref="ViewBase.RemoveItemEvents"/> of base class <see cref="ViewBase"/>.</remarks>
-    protected override void RemoveItemEvents() {
-      operatorGraphView.OperatorGraph = null;
-      operatorBaseVariableInfosView.Operator = null;
-      operatorBaseVariablesView.Operator = null;
-      CombinedOperator.DescriptionChanged -= new EventHandler(CombinedOperator_DescriptionChanged);
-      base.RemoveItemEvents();
-    }
-    
-    /// <summary>
-    /// Adds event handlers in all children and to the underlying <see cref="CombinedOperator"/>.
-    /// </summary>
-    /// <remarks>Calls <see cref="ViewBase.AddItemEvents"/> of base class <see cref="ViewBase"/>.</remarks>
-    protected override void AddItemEvents() {
-      base.AddItemEvents();
-      operatorGraphView.OperatorGraph = CombinedOperator.OperatorGraph;
-      operatorBaseVariableInfosView.Operator = CombinedOperator;
-      operatorBaseVariablesView.Operator = CombinedOperator;
-      CombinedOperator.DescriptionChanged += new EventHandler(CombinedOperator_DescriptionChanged);
-    }
-
-    /// <summary>
-    /// Initializes a new instance of <see cref="CombinedOperatorView"/>.
-    /// </summary>
-    public CombinedOperatorView() {
-      InitializeComponent();
-    }
-    /// <summary>
-    /// Initializes a new instance of <see cref="CombinedOperatorView"/> with the specified 
-    /// <paramref name="combinedOperator"/>.
-    /// </summary>
-    /// <param name="combinedOperator">The combined operator to display.</param>
-    public CombinedOperatorView(CombinedOperator combinedOperator)
-      : this() {
-      CombinedOperator = combinedOperator;
-    }
-
-    /// <summary>
-    /// Updates all controls with the latest data of the model.
-    /// </summary>
-    protected override void UpdateControls() {
-      base.UpdateControls();
-      if (CombinedOperator == null) {
-        descriptionTextBox.Text = "";
-        descriptionTextBox.Enabled = false;
-      } else {
-        descriptionTextBox.Text = CombinedOperator.Description;
-        descriptionTextBox.Enabled = true;
-      }
-    }
-
-    private void CombinedOperator_DescriptionChanged(object sender, EventArgs e) {
-      descriptionTextBox.Text = CombinedOperator.Description;
-    }
-    private void descriptionTextBox_Validated(object sender, EventArgs e) {
-      CombinedOperator.SetDescription(descriptionTextBox.Text);
-    }
-
-    private void operatorBaseVariableInfosView_SelectedVariableInfosChanged(object sender, EventArgs e) {
-      removeVariableInfoButton.Enabled = operatorBaseVariableInfosView.SelectedVariableInfos.Count > 0;
-    }
-
-    #region Click Events
-    private void addVariableInfoButton_Click(object sender, EventArgs e) {
-      AddVariableInfoDialog dialog = new AddVariableInfoDialog();
-      if (dialog.ShowDialog(this) == DialogResult.OK) {
-        if (CombinedOperator.GetVariableInfo(dialog.VariableInfo.FormalName) != null)
-          HeuristicLab.Core.Views.Auxiliary.ShowErrorMessageBox("A variable info with the same formal name already exists.");
-        else
-          CombinedOperator.AddVariableInfo(dialog.VariableInfo);
-      }
-      dialog.Dispose();
-    }
-    private void removeVariableInfoButton_Click(object sender, EventArgs e) {
-      IVariableInfo[] selected = new IVariableInfo[operatorBaseVariableInfosView.SelectedVariableInfos.Count];
-      operatorBaseVariableInfosView.SelectedVariableInfos.CopyTo(selected, 0);
-      for (int i = 0; i < selected.Length; i++)
-        CombinedOperator.RemoveVariableInfo(selected[i].FormalName);
-    }
-    #endregion
-  }
-}
Index: trunk/sources/HeuristicLab.Operators/3.3/CombinedOperatorView.resx
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/CombinedOperatorView.resx	(revision 2664)
+++ 	(revision )
@@ -1,120 +1,0 @@
-<?xml version="1.0" encoding="utf-8"?>
-<root>
-  <!-- 
-    Microsoft ResX Schema 
-    
-    Version 2.0
-    
-    The primary goals of this format is to allow a simple XML format 
-    that is mostly human readable. The generation and parsing of the 
-    various data types are done through the TypeConverter classes 
-    associated with the data types.
-    
-    Example:
-    
-    ... ado.net/XML headers & schema ...
-    <resheader name="resmimetype">text/microsoft-resx</resheader>
-    <resheader name="version">2.0</resheader>
-    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
-    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
-    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
-    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
-    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
-        <value>[base64 mime encoded serialized .NET Framework object]</value>
-    </data>
-    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
-        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
-        <comment>This is a comment</comment>
-    </data>
-                
-    There are any number of "resheader" rows that contain simple 
-    name/value pairs.
-    
-    Each data row contains a name, and value. The row also contains a 
-    type or mimetype. Type corresponds to a .NET class that support 
-    text/value conversion through the TypeConverter architecture. 
-    Classes that don't support this are serialized and stored with the 
-    mimetype set.
-    
-    The mimetype is used for serialized objects, and tells the 
-    ResXResourceReader how to depersist the object. This is currently not 
-    extensible. For a given mimetype the value must be set accordingly:
-    
-    Note - application/x-microsoft.net.object.binary.base64 is the format 
-    that the ResXResourceWriter will generate, however the reader can 
-    read any of the formats listed below.
-    
-    mimetype: application/x-microsoft.net.object.binary.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
-            : and then encoded with base64 encoding.
-    
-    mimetype: application/x-microsoft.net.object.soap.base64
-    value   : The object must be serialized with 
-            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
-            : and then encoded with base64 encoding.
-
-    mimetype: application/x-microsoft.net.object.bytearray.base64
-    value   : The object must be serialized into a byte array 
-            : using a System.ComponentModel.TypeConverter
-            : and then encoded with base64 encoding.
-    -->
-  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
-    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
-    <xsd:element name="root" msdata:IsDataSet="true">
-      <xsd:complexType>
-        <xsd:choice maxOccurs="unbounded">
-          <xsd:element name="metadata">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" />
-              </xsd:sequence>
-              <xsd:attribute name="name" use="required" type="xsd:string" />
-              <xsd:attribute name="type" type="xsd:string" />
-              <xsd:attribute name="mimetype" type="xsd:string" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="assembly">
-            <xsd:complexType>
-              <xsd:attribute name="alias" type="xsd:string" />
-              <xsd:attribute name="name" type="xsd:string" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="data">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
-              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
-              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
-              <xsd:attribute ref="xml:space" />
-            </xsd:complexType>
-          </xsd:element>
-          <xsd:element name="resheader">
-            <xsd:complexType>
-              <xsd:sequence>
-                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
-              </xsd:sequence>
-              <xsd:attribute name="name" type="xsd:string" use="required" />
-            </xsd:complexType>
-          </xsd:element>
-        </xsd:choice>
-      </xsd:complexType>
-    </xsd:element>
-  </xsd:schema>
-  <resheader name="resmimetype">
-    <value>text/microsoft-resx</value>
-  </resheader>
-  <resheader name="version">
-    <value>2.0</value>
-  </resheader>
-  <resheader name="reader">
-    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-  <resheader name="writer">
-    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-</root>
Index: trunk/sources/HeuristicLab.Operators/3.3/Counter.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/Counter.cs	(revision 2664)
+++ trunk/sources/HeuristicLab.Operators/3.3/Counter.cs	(revision 2684)
@@ -25,34 +25,32 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Operators {
   /// <summary>
-  /// Class to increment an int variable by 1.
+  /// Operator which increments an integer variable.
   /// </summary>
-  public class Counter : OperatorBase {
-    /// <summary>
-    /// Gets the description of the current instance.
-    /// </summary>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
+  [Item("Counter", "An operator which increments an integer variable.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public sealed class Counter : StandardOperator {
+    public ItemParameter<IntData> Value {
+      get { return (ItemParameter<IntData>)Parameters["Value"]; }
+    }
+    public ItemParameter<IntData> Increment {
+      get { return (ItemParameter<IntData>)Parameters["Increment"]; }
     }
 
-    /// <summary>
-    /// Initializes a new instance of <see cref="Counter"/> with one variable info (<c>Value</c>).
-    /// </summary>
     public Counter()
       : base() {
-      AddVariableInfo(new VariableInfo("Value", "Counter value", typeof(IntData), VariableKind.In | VariableKind.Out));
+      Parameters.Add(new ItemParameter<IntData>("Value", "The value which should be incremented."));
+      Parameters.Add(new ItemParameter<IntData>("Increment", "The increment which is added to the value.", new IntData(1)));
     }
 
-    /// <summary>
-    /// Increments an int value of the specified <paramref name="scope"/> by one.
-    /// </summary>
-    /// <param name="scope">The scope whose variable should be incremented.</param>
-    /// <returns><c>null</c>.</returns>
-    public override IOperation Apply(IScope scope) {
-      IntData value = GetVariableValue<IntData>("Value", scope, true);
-      value.Data++;
-      return null;
+    public override ExecutionContextCollection Apply(ExecutionContext context) {
+      IntData value = Value.GetValue(context);
+      IntData increment = Increment.GetValue(context);
+      value.Value += increment.Value;
+      return base.Apply(context);
     }
   }
Index: trunk/sources/HeuristicLab.Operators/3.3/EmptyOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/EmptyOperator.cs	(revision 2664)
+++ trunk/sources/HeuristicLab.Operators/3.3/EmptyOperator.cs	(revision 2684)
@@ -31,5 +31,5 @@
   /// An operator which represents an empty statement.
   /// </summary>
-  [Item("Empty Operator", "An operator which represents an empty statement.")]
+  [Item("EmptyOperator", "An operator which represents an empty statement.")]
   [Creatable("Test")]
   [EmptyStorableClass]
Index: trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 2664)
+++ trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 2684)
@@ -85,4 +85,6 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="CombinedOperator.cs" />
+    <Compile Include="Counter.cs" />
     <Compile Include="EmptyOperator.cs">
       <SubType>Code</SubType>
@@ -91,4 +93,5 @@
     <Compile Include="Operator.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="SequentialProcessor.cs" />
     <Compile Include="StandardOperator.cs" />
   </ItemGroup>
Index: trunk/sources/HeuristicLab.Operators/3.3/Operator.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/Operator.cs	(revision 2664)
+++ trunk/sources/HeuristicLab.Operators/3.3/Operator.cs	(revision 2684)
@@ -37,4 +37,7 @@
     public override Image ItemImage {
       get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Method; }
+    }
+    public override bool CanChangeDescription {
+      get { return false; }
     }
 
Index: trunk/sources/HeuristicLab.Operators/3.3/SequentialProcessor.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/SequentialProcessor.cs	(revision 2664)
+++ trunk/sources/HeuristicLab.Operators/3.3/SequentialProcessor.cs	(revision 2684)
@@ -23,27 +23,40 @@
 using System.Collections.Generic;
 using System.Text;
+using System.Xml;
+using HeuristicLab.Collections;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Operators {
   /// <summary>
-  /// Performs <c>n</c> operators on the given scope sequentially.
+  /// Operator which executes multiple operators sequentially.
   /// </summary>
-  public class SequentialProcessor : OperatorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
+  [Item("SequentialProcessor", "An operator which executes multiple operators sequentially.")]
+  [Creatable("Test")]
+  [EmptyStorableClass]
+  public sealed class SequentialProcessor : Operator, IOperator {
+    public new ParameterCollection Parameters {
+      get {
+        return base.Parameters;
+      }
+    }
+    IObservableKeyedCollection<string, IParameter> IOperator.Parameters {
+      get { return Parameters; }
     }
 
-    /// <summary>
-    /// Applies <c>n</c> operators on the given <paramref name="scope"/>.
-    /// </summary>
-    /// <param name="scope">The scope to apply the operators on.</param>
-    /// <returns>A new <see cref="CompositeOperation"/> with the <c>n</c> operators applied 
-    /// to the given <paramref name="scope"/>.</returns>
-    public override IOperation Apply(IScope scope) {
-      CompositeOperation next = new CompositeOperation();
-      for (int i = 0; i < SubOperators.Count; i++)
-        next.AddOperation(new AtomicOperation(SubOperators[i], scope));
+    public SequentialProcessor()
+      : base() {
+    }
+
+    public override ExecutionContextCollection Apply(ExecutionContext context) {
+      ExecutionContextCollection next = new ExecutionContextCollection();
+      foreach (IParameter param in Parameters) {
+        IOperatorParameter opParam = param as IOperatorParameter;
+        if (opParam != null) {
+          IOperator op = (IOperator)opParam.GetValue(context);
+          if (op != null) next.Add(new ExecutionContext(context.Parent, op, context.Scope));
+        }
+      }
       return next;
     }
Index: trunk/sources/HeuristicLab.Operators/3.3/StandardOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/StandardOperator.cs	(revision 2664)
+++ trunk/sources/HeuristicLab.Operators/3.3/StandardOperator.cs	(revision 2684)
@@ -31,5 +31,5 @@
   /// A base class for operators which have only one successor.
   /// </summary>
-  [Item("Standard Operator", "A base class for operators which have only one successor.")]
+  [Item("StandardOperator", "A base class for operators which have only one successor.")]
   [Creatable("Test")]
   [EmptyStorableClass]
@@ -45,5 +45,5 @@
 
     public override ExecutionContextCollection Apply(ExecutionContext context) {
-      IOperator successor = Successor.GetValue(context);
+      IOperator successor = Successor.GetValue(context, false);
       if (successor != null)
         return new ExecutionContextCollection(new ExecutionContext(context.Parent, successor, context.Scope));