Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewEditorToolStripButtonItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewEditorToolStripButtonItem.cs	(revision 2636)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewEditorToolStripButtonItem.cs	(revision 2696)
@@ -6,5 +6,5 @@
 
 namespace HeuristicLab.MainForm.Test {
-  public class NewEditorToolStripButtonItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, ITestUserInterfaceItemProvider {
+  public class NewEditorToolStripButtonItem : HeuristicLab.MainForm.WindowsForms.ToolBarItem, ITestUserInterfaceItemProvider {
     public override int Position {
       get { return 12; }
Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewFormToolStripButtonItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewFormToolStripButtonItem.cs	(revision 2636)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewFormToolStripButtonItem.cs	(revision 2696)
@@ -6,5 +6,5 @@
 
 namespace HeuristicLab.MainForm.Test {
-  public class NewFormToolStripButtonItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, ITestUserInterfaceItemProvider {
+  public class NewFormToolStripButtonItem : HeuristicLab.MainForm.WindowsForms.ToolBarItem, ITestUserInterfaceItemProvider {
     public override int Position {
       get { return 11; }
Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewToolStripButtonItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewToolStripButtonItem.cs	(revision 2636)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/NewToolStripButtonItem.cs	(revision 2696)
@@ -6,5 +6,5 @@
 
 namespace HeuristicLab.MainForm.Test {
-  public class NewToolStripButtonItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, ITestUserInterfaceItemProvider {
+  public class NewToolStripButtonItem : HeuristicLab.MainForm.WindowsForms.ToolBarItem, ITestUserInterfaceItemProvider {
     public override int Position {
       get { return 10; }
Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/OpenToolStripButtonItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/OpenToolStripButtonItem.cs	(revision 2636)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/OpenToolStripButtonItem.cs	(revision 2696)
@@ -6,5 +6,10 @@
 
 namespace HeuristicLab.MainForm.Test {
-  public class OpenToolStripButtonItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, ITestUserInterfaceItemProvider {
+  public class OpenToolStripButtonItem : HeuristicLab.MainForm.WindowsForms.ToolBarItem, ITestUserInterfaceItemProvider {
+
+    public OpenToolStripButtonItem()
+      : base() {
+      System.Console.Out.Write("test");
+    }
     public override int Position {
       get { return 20; }
@@ -23,8 +28,8 @@
     }
 
-    public override void ActiveViewChanged(object sender, EventArgs e) {
+    protected override void OnActiveViewChanged(object sender, EventArgs e) {
       this.ToolStripItem.Enabled = !this.ToolStripItem.Enabled;
-      MainFormManager.MainForm.Title = 
-        MainFormManager.MainForm.ActiveView == null ? "null" : MainFormManager.MainForm.ActiveView.Caption;
+      //MainFormManager.MainForm.Title = 
+      //  MainFormManager.MainForm.ActiveView == null ? "null" : MainFormManager.MainForm.ActiveView.Caption;
     }
   }
Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/SaveToolStripButtonItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/SaveToolStripButtonItem.cs	(revision 2636)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/SaveToolStripButtonItem.cs	(revision 2696)
@@ -6,5 +6,5 @@
 
 namespace HeuristicLab.MainForm.Test {
-  public class SaveToolStripButtonItem : HeuristicLab.MainForm.WindowsForms.ToolBarItemBase, ITestUserInterfaceItemProvider {
+  public class SaveToolStripButtonItem : HeuristicLab.MainForm.WindowsForms.ToolBarItem, ITestUserInterfaceItemProvider {
     public override int Position {
       get { return 30; }
@@ -23,5 +23,5 @@
     }
 
-    public override void ActiveViewChanged(object sender, EventArgs e) {
+    protected override void OnActiveViewChanged(object sender, EventArgs e) {
       IMainForm mainform = MainFormManager.MainForm;
       if (mainform.ActiveView == null)
@@ -31,5 +31,5 @@
     }
 
-    public override void ViewChanged(object sender, EventArgs e) {
+    protected override void OnViewChanged(object sender, EventArgs e) {
       this.ToolStripItem.Enabled = !this.ToolStripItem.Enabled;
     }
Index: trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/SeparatorToolStripButtonItem.cs
===================================================================
--- trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/SeparatorToolStripButtonItem.cs	(revision 2636)
+++ trunk/sources/HeuristicLab.MainForm.Test/3.2/ButtonItems/SeparatorToolStripButtonItem.cs	(revision 2696)
@@ -6,5 +6,5 @@
 
 namespace HeuristicLab.MainForm.Test {
-  public class SeparatorToolStripButtonItem : ToolBarSeparatorItemBase, ITestUserInterfaceItemProvider {
+  public class SeparatorToolStripButtonItem : ToolBarSeparatorItem, ITestUserInterfaceItemProvider {
     public override int Position {
       get { return 15; }