Index: /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ContentView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ContentView.Designer.cs	(revision 2711)
+++ /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ContentView.Designer.cs	(revision 2712)
@@ -11,6 +11,7 @@
     /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
     protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
+      if (disposing) {
+        if (Content != null) DeregisterContentEvents();
+        if (components != null) components.Dispose();
       }
       base.Dispose(disposing);
Index: /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ContentView.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ContentView.cs	(revision 2711)
+++ /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.2/ContentView.cs	(revision 2712)
@@ -30,5 +30,5 @@
 
 namespace HeuristicLab.MainForm.WindowsForms {
-  public partial class ContentView : View {
+  public partial class ContentView : View, IContentView {
     public ContentView()
       : base() {
@@ -51,10 +51,8 @@
         } else {
           if (this.content != value) {
-            if (this.content != null)
-              this.DeregisterObjectEvents();
+            if (this.content != null) this.DeregisterContentEvents();
             this.content = value;
-            this.OnContentChanged(new EventArgs());
-            if (this.content != null)
-              this.RegisterObjectEvents();
+            this.OnContentChanged();
+            if (this.content != null) this.RegisterContentEvents();
           }
         }
@@ -65,5 +63,5 @@
     /// Adds eventhandlers to the current instance.
     /// </summary>
-    protected virtual void RegisterObjectEvents() {
+    protected virtual void RegisterContentEvents() {
     }
 
@@ -71,5 +69,5 @@
     /// Removes the eventhandlers from the current instance.
     /// </summary>
-    protected virtual void DeregisterObjectEvents() {
+    protected virtual void DeregisterContentEvents() {
     }
 
@@ -77,7 +75,6 @@
     /// Is called when the content property changes.
     /// </summary>
-    protected virtual void OnContentChanged(EventArgs e) {
+    protected virtual void OnContentChanged() {
     }
-
   }
 }
Index: /trunk/sources/HeuristicLab.MainForm/3.2/HeuristicLab.MainForm-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.MainForm/3.2/HeuristicLab.MainForm-3.2.csproj	(revision 2711)
+++ /trunk/sources/HeuristicLab.MainForm/3.2/HeuristicLab.MainForm-3.2.csproj	(revision 2712)
@@ -81,4 +81,5 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Interfaces\IContentView.cs" />
     <Compile Include="Interfaces\IActionUserInterfaceItem.cs" />
     <Compile Include="Interfaces\IPositionableUserInterfaceItem.cs" />
Index: /trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IContentView.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IContentView.cs	(revision 2712)
+++ /trunk/sources/HeuristicLab.MainForm/3.2/Interfaces/IContentView.cs	(revision 2712)
@@ -0,0 +1,31 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.ComponentModel;
+
+namespace HeuristicLab.MainForm {
+  public interface IContentView : IView {
+    object Content { get; }
+  }
+}