Index: trunk/sources/HeuristicLab.Operators.Views/3.3/CombinedOperatorView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views/3.3/CombinedOperatorView.Designer.cs	(revision 2684)
+++ trunk/sources/HeuristicLab.Operators.Views/3.3/CombinedOperatorView.Designer.cs	(revision 2713)
@@ -109,9 +109,6 @@
                   | System.Windows.Forms.AnchorStyles.Right)));
       this.parameterCollectionView.Caption = "ParameterCollection";
-      this.parameterCollectionView.ItemCollection = null;
       this.parameterCollectionView.Location = new System.Drawing.Point(6, 6);
       this.parameterCollectionView.Name = "parameterCollectionView";
-      this.parameterCollectionView.NamedItemCollection = null;
-      this.parameterCollectionView.Object = null;
       this.parameterCollectionView.Size = new System.Drawing.Size(466, 326);
       this.parameterCollectionView.TabIndex = 0;
@@ -123,9 +120,6 @@
                   | System.Windows.Forms.AnchorStyles.Right)));
       this.operatorGraphView.Caption = "Operator Graph";
-      this.operatorGraphView.Item = null;
       this.operatorGraphView.Location = new System.Drawing.Point(6, 6);
       this.operatorGraphView.Name = "operatorGraphView";
-      this.operatorGraphView.Object = null;
-      this.operatorGraphView.OperatorGraph = null;
       this.operatorGraphView.Size = new System.Drawing.Size(466, 326);
       this.operatorGraphView.TabIndex = 0;
Index: trunk/sources/HeuristicLab.Operators.Views/3.3/CombinedOperatorView.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views/3.3/CombinedOperatorView.cs	(revision 2684)
+++ trunk/sources/HeuristicLab.Operators.Views/3.3/CombinedOperatorView.cs	(revision 2713)
@@ -37,7 +37,7 @@
   [Content(typeof(CombinedOperator), true)]
   public partial class CombinedOperatorView : NamedItemView {
-    public CombinedOperator CombinedOperator {
-      get { return (CombinedOperator)base.Item; }
-      set { base.Item = value; }
+    public new CombinedOperator Content {
+      get { return (CombinedOperator)base.Content; }
+      set { base.Content = value; }
     }
 
@@ -54,16 +54,16 @@
     public CombinedOperatorView(CombinedOperator combinedOperator)
       : this() {
-      CombinedOperator = combinedOperator;
+      Content = combinedOperator;
     }
 
-    protected override void OnObjectChanged() {
-      base.OnObjectChanged();
-      if (CombinedOperator == null) {
-        parameterCollectionView.NamedItemCollection = null;
-        operatorGraphView.OperatorGraph = null;
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        parameterCollectionView.Content = null;
+        operatorGraphView.Content = null;
         tabControl.Enabled = false;
       } else {
-        parameterCollectionView.NamedItemCollection = ((IOperator)CombinedOperator).Parameters;
-        operatorGraphView.OperatorGraph = CombinedOperator.OperatorGraph;
+        parameterCollectionView.Content = ((IOperator)Content).Parameters;
+        operatorGraphView.Content = Content.OperatorGraph;
         tabControl.Enabled = true;
       }
Index: trunk/sources/HeuristicLab.Operators.Views/3.3/OperatorView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views/3.3/OperatorView.Designer.cs	(revision 2684)
+++ trunk/sources/HeuristicLab.Operators.Views/3.3/OperatorView.Designer.cs	(revision 2713)
@@ -67,9 +67,6 @@
                   | System.Windows.Forms.AnchorStyles.Right)));
       this.parameterCollectionView.Caption = "ParameterCollection";
-      this.parameterCollectionView.ItemCollection = null;
       this.parameterCollectionView.Location = new System.Drawing.Point(0, 119);
       this.parameterCollectionView.Name = "parameterCollectionView";
-      this.parameterCollectionView.NamedItemCollection = null;
-      this.parameterCollectionView.Object = null;
       this.parameterCollectionView.Size = new System.Drawing.Size(490, 234);
       this.parameterCollectionView.TabIndex = 4;
Index: trunk/sources/HeuristicLab.Operators.Views/3.3/OperatorView.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views/3.3/OperatorView.cs	(revision 2684)
+++ trunk/sources/HeuristicLab.Operators.Views/3.3/OperatorView.cs	(revision 2713)
@@ -37,7 +37,7 @@
   [Content(typeof(Operator), true)]
   public partial class OperatorView : NamedItemView {
-    public Operator Operator {
-      get { return (Operator)base.Item; }
-      set { base.Item = value; }
+    public new Operator Content {
+      get { return (Operator)base.Content; }
+      set { base.Content = value; }
     }
 
@@ -54,13 +54,13 @@
     public OperatorView(Operator op)
       : this() {
-      Operator = op;
+      Content = op;
     }
 
-    protected override void OnObjectChanged() {
-      base.OnObjectChanged();
-      if (Operator == null) {
-        parameterCollectionView.NamedItemCollection = null;
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        parameterCollectionView.Content = null;
       } else {
-        parameterCollectionView.NamedItemCollection = ((IOperator)Operator).Parameters;
+        parameterCollectionView.Content = ((IOperator)Content).Parameters;
       }
     }